﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RównanieKwadratowe
{
    //nie można zmieniać stanu instancji tej klasy
    internal class RównanieKwadratowe
    {
        double a, b, c;

        public RównanieKwadratowe(double a, double b, double c)
        {
            this.a = a;
            this.b = b;
            this.c = c;
            rozwiąż();
        }

        public double? X1 { get; private set; } = null;
        public double? X2 { get; private set; } = null;

        private void rozwiąż()
        {
            double delta = b * b - 4 * a * c;
            if (delta >= 0)
            {
                double pieriastekZDelty = Math.Sqrt(delta);
                X1 = (-b - pieriastekZDelty) / (2 * a);
                X2 = (-b + pieriastekZDelty) / (2 * a);
            }
            else
            {
                X1 = null;
                X2 = null;
            }
        }
    }

    TODO: zrobić wersję ze zmianą zoptymalizowaną do częstego odczytu i zapisu
    TODO: zrobić wersję smart z flagą wymuszającą obliczenia
}
